#pragma option -3 -a -b -d -f287 -ff -G -K- -k -N -r -v -Y- -y -Z
#pragma option -k- -N- -O2 -v- -y-
#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#include <time.h>
#include <math.h>

#define GR_DRV 9
#define GR_MODE 1
#define GR_PAGES 2

int gr_page=GR_PAGES-1;

int initgr(void);
void switchpages(void);


const long double range=210,range_asp=288,aspratio=48.L/35.L;
const long double timestep=.1L/CLK_TCK,timepart=1.L/8.L,sinfactor=M_PI*2.L;
const long double timestep_asp=timestep/aspratio;

const long double freq_step_0=1.L,freq_step_1=0.1L,freq_step_2=0.01L,
  freq_eps=0.0005L;
const long double phase_step_0=.5L,phase_step_1=0.05L,phase_step_2=0.005L;
const clock_t time_delays[10]={-1,0,1,2,3,4,6,9,12,18};
const long double time_factors[10]={1.L,1.5L,2.L,2.5L,3.L,4.L,5.L,10.L,15.L,20.L};

long double freq_y=5.L,freq_x=5.L,phase_y=0,phase_x=0;
clock_t time_delay=0; long double time_factor=1.L;
long double adequaty=1,quality=1,precision=1;
int f_exit=0,f_step=0,f_repaint=1,f_metrics=1,f_info=1,f_info_full=1,f_help=1;

void next(void) {
  phase_y=fmodl(phase_y+freq_y/CLK_TCK/time_factor,1.L);
  phase_x=fmodl(phase_x+freq_x/CLK_TCK/time_factor,1.L);
}
void paint(void) {
  long double step_y,step_x,ratio_y,ratio_x,range_y,range_x;
  long double i_y,i_x,t_y,t_x,f_y,f_x; int x,y;
  step_y=timepart/adequaty/freq_y; step_x=timepart/adequaty/freq_x;
  if (step_y>timestep_asp*quality)
    step_y/=(long double)((int)(step_y/timestep_asp/quality));
  if (step_x>timestep*quality)
    step_x/=(long double)((int)(step_x/timestep/quality));
  ratio_y=step_y/timestep_asp; ratio_x=step_x/timestep;
  range_y=range_asp*timestep_asp/step_y; range_x=range*timestep/step_x;
  setcolor(10);
    f_y=sin(phase_y*sinfactor);
    x=178; y=(int)(70-50*f_y);
    moveto(x,y);
  t_y=step_y-fmodl(phase_y/freq_y,step_y);
  for (i_y=t_y/step_y; i_y<range_y; i_y++,t_y+=step_y) {
    f_y=sin((t_y*freq_y+phase_y)*sinfactor);
    x=178+(int)(i_y*ratio_y); y=(int)(70-50*f_y);
    lineto(x,y);
  }
    f_x=sin(phase_x*sinfactor);
    y=130; x=(int)((70+50*f_x)*aspratio);
    moveto(x,y);
  t_x=step_x-fmodl(phase_x/freq_x,step_x);
  for (i_x=t_x/step_x; i_x<range_x; i_x++,t_x+=step_x) {
    f_x=sin((t_x*freq_x+phase_x)*sinfactor);
    y=130+(int)(i_x*ratio_x); x=(int)((70+50*f_x)*aspratio);
    lineto(x,y);
  }
  step_x/=precision; step_y/=precision;
  ratio_y=step_y/timestep_asp; ratio_x=step_x/timestep;
  range_y=range_asp*timestep_asp/step_y; range_x=range*timestep/step_x;
    f_y=sin(phase_y*sinfactor);
    f_x=sin(phase_x*sinfactor);
    y=(int)(70-50*f_y);
    x=(int)((70+50*f_x)*aspratio);
    moveto(x,y);
  t_y=step_y-fmodl(phase_y/freq_y,step_y); i_y=t_y/step_y;
  t_x=step_x-fmodl(phase_x/freq_x,step_x); i_x=t_x/step_x;
  while ((i_y<range_y)||(i_x<range_x)) {
    if (t_y<=t_x) {
      f_y=sin((t_y*freq_y+phase_y)*sinfactor);
      f_x=sin((t_y*freq_x+phase_x)*sinfactor);
      i_y++; t_y+=step_y;
    } else {
      f_y=sin((t_x*freq_y+phase_y)*sinfactor);
      f_x=sin((t_x*freq_x+phase_x)*sinfactor);
      i_x++; t_x+=step_y;
    }
    y=(int)(70-50*f_y);
    x=(int)((70+50*f_x)*aspratio);
    lineto(x,y);
  }
}
void printinfo(void) {
  if (!f_info) return;
  char str[64]; long double z0,z1;
  setcolor(14); settextjustify(0,2);
  sprintf(str,"y: freq=%6.2LfHz phase=%.3Lf*pi",freq_y,phase_y*2.L);
  outtextxy(205,150,str);
  sprintf(str,"x: freq=%6.2LfHz phase=%.3Lf*pi",freq_x,phase_x*2.L);
  outtextxy(205,160,str);
  z0=phase_y-phase_x; z1=phase_y-phase_x/freq_x*freq_y;
  while (z0<=-.5L) z0+=1.L; while (z0>.5L) z0-=1.L;
  while (z1<=-.5L) z1+=1.L; while (z1>.5L) z1-=1.L;
  sprintf(str,"pshift=%+.3Lf*pi initshift=%+.3Lf*pi",z0*2.L,z1*2.L);
  outtextxy(205,170,str);
  if (!f_info_full) return;
  if (time_delay!=-1)
    sprintf(str,"delay=%5.2Lfsec ratio=%5.2Lf step=%5.3Lf",
    ((long double)time_delay)/CLK_TCK,(long double)time_delay,1.L/time_factor);
  else sprintf(str,"delay=infinity             step=%5.3Lf",1.L/time_factor);
  outtextxy(205,185,str);
  sprintf(str,"quality   = %12.7Lf",1.L/quality,precision,adequaty);
  outtextxy(205,200,str);
  sprintf(str,"precision = %12.7Lf",precision);
  outtextxy(205,210,str);
  sprintf(str,"adequaty  = %12.7Lf",adequaty);
  outtextxy(205,220,str);
}
void printhelp(void) {
  if (!f_help) return;
  setcolor(6); settextjustify(0,2);
  outtextxy(205,240,"1,2,3,4,5,6,7,8,9,0 - speed     space - do step");
  outtextxy(205,250,"shift+1,2,3,4,5,6,7,8,9,0 - time step");
  outtextxy(205,263,"right/left,up/down - y,x freq up/down");
  outtextxy(205,273,"home/end,ins/del,pgup/pgdn - y,x,both phases up/down");
  outtextxy(205,283,"pure key/ctrl+key/alt+key - rude/normal/fine");
  outtextxy(205,293,"backspace/enter - sync freqs/phases");
  outtextxy(205,306,"-/= , [/] , ;/\' - quality,precision,adequaty up/down");
  outtextxy(205,319,"`,tab,\\,? - toggle metrics,info,setting,help");
  outtextxy(205,331,"ESC - quit");
}
void form(void) {
  int i,x,y; char str[8];
  setcolor(8);
  line(13,20,466,20); line(13,45,466,45); line(13,70,466,70);
  line(13,95,466,95); line(13,120,466,120);
  line(27,10,27,340); line(61,10,61,340); line(96,10,96,340);
  line(130,10,130,340); line(164,10,164,340);
  setcolor(7);
  line(178,10,178,125); line(178,10,175,15); line(178,10,181,15);
  line(178,70,466,70); line(459,68,466,70); line(459,72,466,70);
  line(13,130,178,130); line(171,128,178,130); line(171,132,178,130);
  line(96,130,96,340); line(93,335,96,340); line(99,335,96,340);
 if (f_metrics) {
  line(174,20,182,20); line(174,45,182,45);
  line(174,95,182,95); line(174,120,182,120);
  line(27,127,27,133); line(61,127,61,133);
  line(130,127,130,133); line(164,127,164,133);
  for (i=1; i<=20; i++) { x=(130+i*10)*48/35; line(x,i&3?68:66,x,i&3?72:74); }
  for (i=1; i<=20; i++) { y=(130+i*10); line(i&3?93:90,y,i&3?99:102,y); }
  settextjustify(1,0); outtextxy(178,8,"y");
  settextjustify(0,1); outtextxy(181,130,"x");
  settextjustify(0,1); outtextxy(469,70,"t,sec");
  settextjustify(1,2); outtextxy(96,341,"t,sec");
  settextjustify(0,1);
  outtextxy(185,20+1,"+1"); outtextxy(185,45+1,"+.5");
  outtextxy(185,95+1,"-.5"); outtextxy(185,120+1,"-1");
  settextjustify(1,2);
  outtextxy(27-1,135,"-1"); outtextxy(61-1,135,"-.5");
  outtextxy(130-1,135,"+.5"); outtextxy(164-1,135,"+1");
  settextjustify(1,2); for (i=4; i<=20; i+=4) {
    x=(130+i*10)*48/35;
    sprintf(str,"%.2Lf",((long double)i)/CLK_TCK); outtextxy(x-1,76,str);
  }
  settextjustify(0,1); for (i=4; i<=20; i+=4) {
    y=(130+i*10);
    sprintf(str,"%.2Lf",((long double)i)/CLK_TCK); outtextxy(106,y+1,str);
  }
 }
}

int main(void) {
  int ch;
  clock_t time_cur,time_prev;
  if (initgr()) return(-1);
  switchpages();
  time_prev=clock();
  do {
    time_cur=clock();
    if ((time_cur-time_prev>=time_delay)&&(time_delay!=-1)) {
      f_step=1;
      time_prev=time_cur;
    }
    if (f_step) {
      next();
      f_repaint=1; f_step=0;
    }
    if (f_repaint) {
      cleardevice();
      form(); paint();
      printinfo(); printhelp();
      switchpages();
      f_repaint=0;
    }
    while (kbhit()) {
      ch=getch();
      if (ch) {
        if ((ch>='0')&&(ch<='9')) time_delay=time_delays[ch-'0']; else
        switch (ch) {
          case 27: f_exit++; break;
          case 32: f_step=1; break;
          case '`': f_metrics^=1; break;
          case 9: f_info^=1; break;
          case '\\': f_info_full^=1; break;
          case '/': f_help^=1; break;
          case '?': f_help^=1; break;
          case '-': quality*=2; break;
          case '=': quality/=2; break;
          case '[': precision/=2; break;
          case ']': precision*=2; break;
          case ';': adequaty/=2; break;
          case '\'': adequaty*=2; break;
          case 8: freq_x=freq_y; break;
          case 13: phase_x=phase_y=0; break;
          case '!': time_factor=time_factors[0]; break;
          case '@': time_factor=time_factors[1]; break;
          case '#': time_factor=time_factors[2]; break;
          case '$': time_factor=time_factors[3]; break;
          case '%': time_factor=time_factors[4]; break;
          case '^': time_factor=time_factors[5]; break;
          case '&': time_factor=time_factors[6]; break;
          case '*': time_factor=time_factors[7]; break;
          case '(': time_factor=time_factors[8]; break;
          case ')': time_factor=time_factors[9]; break;
        }
      } else {
        ch=getch();
        switch (ch) {
          case 77: freq_y+=freq_step_0; break;
          case 75: if (freq_y>freq_step_0+freq_eps) freq_y-=freq_step_0; break;
          case 116: freq_y+=freq_step_1; break;
          case 115: if (freq_y>freq_step_1+freq_eps) freq_y-=freq_step_1; break;
          case 157: freq_y+=freq_step_2; break;
          case 155: if (freq_y>freq_step_2+freq_eps) freq_y-=freq_step_2; break;
          case 72: freq_x+=freq_step_0; break;
          case 80: if (freq_x>freq_step_0+freq_eps) freq_x-=freq_step_0; break;
          case 141: freq_x+=freq_step_1; break;
          case 145: if (freq_x>freq_step_1+freq_eps) freq_x-=freq_step_1; break;
          case 152: freq_x+=freq_step_2; break;
          case 160: if (freq_x>freq_step_2+freq_eps) freq_x-=freq_step_2; break;
          case 71: phase_y=fmodl(phase_y+phase_step_0+1.L,1.L); break;
          case 119: phase_y=fmodl(phase_y+phase_step_1+1.L,1.L); break;
          case 151: phase_y=fmodl(phase_y+phase_step_2+1.L,1.L); break;
          case 79: phase_y=fmodl(phase_y-phase_step_0+1.L,1.L); break;
          case 117: phase_y=fmodl(phase_y-phase_step_1+1.L,1.L); break;
          case 159: phase_y=fmodl(phase_y-phase_step_2+1.L,1.L); break;
          case 82: phase_x=fmodl(phase_x+phase_step_0+1.L,1.L); break;
          case 146: phase_x=fmodl(phase_x+phase_step_1+1.L,1.L); break;
          case 162: phase_x=fmodl(phase_x+phase_step_2+1.L,1.L); break;
          case 83: phase_x=fmodl(phase_x-phase_step_0+1.L,1.L); break;
          case 147: phase_x=fmodl(phase_x-phase_step_1+1.L,1.L); break;
          case 163: phase_x=fmodl(phase_x-phase_step_2+1.L,1.L); break;
          case 73: phase_y=fmodl(phase_y+phase_step_0+1.L,1.L);
            phase_x=fmodl(phase_x+phase_step_0+1.L,1.L); break;
          case 132: phase_y=fmodl(phase_y+phase_step_1+1.L,1.L);
            phase_x=fmodl(phase_x+phase_step_1+1.L,1.L); break;
          case 153: phase_y=fmodl(phase_y+phase_step_2+1.L,1.L);
            phase_x=fmodl(phase_x+phase_step_2+1.L,1.L); break;
          case 81: phase_y=fmodl(phase_y-phase_step_0+1.L,1.L);
            phase_x=fmodl(phase_x-phase_step_0+1.L,1.L); break;
          case 118: phase_y=fmodl(phase_y-phase_step_1+1.L,1.L);
            phase_x=fmodl(phase_x-phase_step_1+1.L,1.L); break;
          case 161: phase_y=fmodl(phase_y-phase_step_2+1.L,1.L);
            phase_x=fmodl(phase_x-phase_step_2+1.L,1.L); break;
        }
      }
      f_repaint=1;
    }
  } while (!f_exit);
  closegraph();
  return(0);
}


int initgr(void) {
  int drv,md,e=0;
  drv=GR_DRV; md=GR_MODE;
  initgraph(&drv,&md,""); e=graphresult();
  if (e) {
    drv=GR_DRV; md=GR_MODE;
    initgraph(&drv,&md,"C:\\"); e=graphresult();
  }
  if (e) {
    drv=GR_DRV; md=GR_MODE;
    initgraph(&drv,&md,"C:\\GRAPHICS.BGI"); e=graphresult();
  }
  if (e) return(-1);
  return(0);
}
void switchpages(void) {
  while ((inportb(0x03DA)&8)); while (!(inportb(0x03DA)&8));
  setvisualpage(gr_page);
  gr_page=(gr_page+1)%GR_PAGES;
  setactivepage(gr_page);
}

